.\"	$NetBSD: last.1,v 1.17 2006/12/27 18:03:26 pooka Exp $
.\"
.\" Copyright (c) 1980, 1990, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)last.1	8.1 (Berkeley) 6/6/93
.\"
.Dd December 27, 2006
.Dt LAST 1
.Os
.Sh NAME
.Nm last
.Nd indicate last logins of users and ttys
.Sh SYNOPSIS
.Nm
.Op Fl Ns Ar n
.Op Fl nTx
.Op Fl f Ar file
.Op Fl H Ar hostsize
.Op Fl h Ar host
.Op Fl L Ar linesize
.Op Fl N Ar namesize
.Op Fl t Ar tty
.Op user ...
.Sh DESCRIPTION
.Nm
will list the sessions of specified
.Ar users ,
.Ar ttys ,
and
.Ar hosts ,
in reverse time order.
Each line of output contains
the user name, the tty from which the session was conducted, any
hostname, the start and stop times for the session, and the duration
of the session.
If the session is still continuing or was cut short by
a crash or shutdown,
.Nm
will so indicate.
.Pp
.Bl -tag -width xHxhostsizexx
.It Fl Ar n
Limits the report to
.Ar n
lines.
.It Fl f Ar file
.Nm
reads the file
.Ar file
instead of the default,
.Pa /var/log/wtmpx
or
.Pa /var/log/wtmp .
If the file ends with
.Sq x ,
it is treated as a
.Xr utmpx 5
format file, else it is treated as a
.Xr utmp 5
format file.
If the file is ``-'', standard input is used.
.It Fl H Ar hostsize
Use the provided hostsize as the width to format the host name field.
.It Fl h Ar host
.Ar Host
names may be names or internet numbers.
.It Fl L Ar linesize
Use the provided linesize as the width to format the tty field.
.It Fl N Ar namesize
Use the provided namesize as the width to format the login name field.
.It Fl n
Print host addresses numerically.
This option works only on
.Xr wtmpx 5
entries,
and prints nothing on
.Xr wtmp 5
entries.
.It Fl T
Display better time information, including the year and seconds.
.It Fl t Ar tty
Specify the
.Ar tty .
Tty names may be given fully or abbreviated, for example,
.Dq Li "last -t 03"
is equivalent to
.Dq Li "last -t tty03" .
.It Fl x
Assume that the file given is
.Xr wtmpx 5
format, even if the filename does not end with an
.Sq x .
.El
.Pp
If multiple arguments are given, the information which applies to any of the
arguments is printed, e.g.,
.Dq Li "last root -t console"
would list all of
.Dq Li root Ns 's
sessions as well as all sessions on the console terminal.
If no users, hostnames, or terminals are specified,
.Nm
prints a record of all logins and logouts.
.Pp
The pseudo-user
.Ar reboot
logs in at reboots of the system, thus
.Dq Li last reboot
will give an indication of mean time between reboot.
.Pp
If
.Nm
is interrupted, it indicates to what date the search has progressed.
If interrupted with a quit signal
.Nm
indicates how far the search has progressed and then continues.
.Sh FILES
.Bl -tag -width /var/log/wtmpx -compact
.It Pa /var/log/wtmp
login data base
.It Pa /var/log/wtmpx
login data base
.El
.Sh SEE ALSO
.Xr lastcomm 1 ,
.Xr utmp 5 ,
.Xr utmpx 5 ,
.Xr ac 8 ,
.Xr lastlogin 8
.Sh HISTORY
.Nm
appeared in
.Bx 3.0 .
